/*	Maze Generator

	Anthony Kozar
	April 10, 2001: original code for school project
	April 16, 2004: modified to generate random mazes
	May 29, 2004: modified for use with LodeRunner 2 level creator
	May 12, 2005: removed print statements & cleaned up MakeOneMaze().
 */

#include	<iostream>
#include	<fstream>
#include	<string>

#include	"mazegen.h"

maze_type<simple_block>* MakeOneMaze()
{
	int	rows, columns;
	//coord	start, finish;
	maze_type<simple_block>* maze = NULL;

	cout	<< "Number of rows? ";
	cin	>> rows;
	cout	<< "Number of columns? ";
	cin	>> columns;

	maze = GenerateMaze(rows, columns);
	return maze;
}

maze_type<simple_block>* GenerateMaze( int rows, int columns )
{
	maze_type<simple_block>* maze = NULL;
	maze = new maze_type<simple_block>(columns, rows);
	if	(! maze->make_maze())	{
		cerr	<< "make_maze() failed!\n";
		exit(1);
	}
	return maze;
}

void	read_maze( maze_type<simple_block>& theMaze )
{
	ifstream	fin;
	coord		wall;
	int		wall_count;
	string	filename;
	
	// open "a:mazein.txt" or prompt for a filename if it does not exist
	fin.open("a:mazein.txt");
	while	( fin.fail() )	{
		cout	<< "Unable to open the input file. Please enter a filename to open: ";
		cin	>> filename;
		fin.clear();
		fin.open(filename.c_str());
	}
	
	// read in sets of coordinates for walls one at a time, checking and then placing them
	wall_count = 0;
	cout << "Reading solid coordinates from file." << endl << endl;
	while	( fin >> wall.first )	{
		fin >> wall.second;
		if	( wall.first < 1 || wall.first > 20 || wall.second < 1 || wall.second > 20 )	{
			cout << "There was an error reading in the file." << endl;
			exit(-1);
		}
		
		theMaze.place_wall( wall );
		wall_count++;
	}
	
	cout	<< wall_count << " solid blocks placed in maze." << endl << endl;
	fin.close();

	return;
}	
	
		